﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDGMultiSelectDropDownCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }
        public List<string> ComboData { get; set; }

        string[] names = "Andrew;Alex;Devin;Lisa;Emilie;Pamela;Mike;Kevin;Steve;Eric".Split(';');
        
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();
            ComboData = names.ToList();

            for(int i=0; i<names.Length; i++)
            {
                SampleData sd = new SampleData() { ID = i, NameFilter = names[i], NameString = names[i] };                
                Data.Add(sd);
            }          
        }
    }

    public class SampleData : INotifyPropertyChanged
    {
        private int _id;
        private string _namefilter;
        private string _namestring;

        public int ID
        {
            get { return _id; }
            set
            {
                if(_id != value)
                {
                    _id = value;
                    OnPropertyChanged();
                }
            }
        }

        public string NameString
        {
            get { return _namestring; }
            set
            {
                if(_namestring != value)
                {
                    _namestring = value;
                    this.NameFilter = "Contains " + value;
                    OnPropertyChanged();
                }
            }
        }              

        public string NameFilter
        {
            get { return _namefilter; }
            set
            {
                if(_namefilter != value)
                {
                    _namefilter = value;
                    OnPropertyChanged();
                }
            }
        }                      

        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
