﻿using Infragistics.Controls.Editors;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Interactivity;

namespace XDGMultiSelectDropDownCase
{
    public class XamComboEditorBehavior : Behavior<XamComboEditor>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.SelectionChanged += AssociatedObject_SelectionChanged;
        }

        private void AssociatedObject_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            CellValuePresenter cvp = Infragistics.Windows.Utilities.GetAncestorFromType(AssociatedObject, typeof(CellValuePresenter), false) as CellValuePresenter;

            if (cvp != null)
            {
                string str = string.Empty;

                if(AssociatedObject.SelectedItems != null && (AssociatedObject.SelectedItems.Count == 1  || AssociatedObject.SelectedItems.Count == 0))
                {
                    return;
                }

                foreach (var x in AssociatedObject.SelectedItems)
                {
                    if (!(x == AssociatedObject.SelectedItems.Last()))
                    {
                        str += x.ToString() + ", ";
                    }
                    else
                    {
                        str += x.ToString();
                    }
                }

                SampleData sd = cvp.Record.DataItem as SampleData;
                sd.NameString = str;
            }
        }     
    }
}
